#!/usr/bin/perl

######################################
#                                    #
# users.cgi v1.0 April 2002          #
#                                    #
# Written by Scott David Gray        #
#                                    #
# Contact:                           #
#  Scott David Gray                  #
#                                    #
# email: sgray@sudval.org            #
#                                    #
# URL: http://unseelie.org           #
#                                    #
# (c) 2001, 2002 by Scott David Gray #
#                                    #
#################################################################
#                                                               #
# This program is free software; you can redistribute it and/or #
# modify it under the terms of the GNU General Public License   #
# as published by the Free Software Foundation; either version  #
# 2 of the License, or (at your option) any later version.      #
#                                                               #
# This program is distributed in the hope that it will be       #
# useful, but WITHOUT ANY WARRANTY; without even the implied    #
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR       #
# PURPOSE.  See the GNU General Public License for more         #
# details.                                                      #
#                                                               #
# You should have received a copy of the GNU General Public     #
# License along with this program; if not, write to the Free    #
# Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, #
# USA.                                                          #
#                                                               #
#                                                               #
#################################################################

#
# User variables -- set these variables according to your system
#

$dirlocation = "/httpd/htdocs/users/" ;

$machinename = "Stuart.unseelie.org" ;

$urlplace ="http://stuart.unseelie.org/users/" ;

$maxaliaslength = 25 ;

$maxcommentlength = 60 ;

#
# Program
#

print <<EOF;
Content-type: text/html
Pragma: no-cache

      <center>
       <b>
        The following users have pages on $machinename:
       </b>
      </center>
       <ol>
EOF

opendir (DIRLOCATION, $dirlocation) ;

while ( defined ($filename = readdir(DIRLOCATION)) ) {

  if ($filename !~ /^\./ ) {

    if (-d "$dirlocation$filename") {

      if ((!-e "$dirlocation$filename\/.stealth") && ((-e "$dirlocation$filename\/index.htm") || (-e "$dirlocation$filename\/index.html"))) {

        print ("        <li><a href=\"$urlplace$filename/\">") ;

        $username = $filename ;

        if (-e "$dirlocation$filename\/.alias") {

          open (ALIASFILE, "< $dirlocation$filename\/.alias") ;

          @aliasfile=<ALIASFILE> ;

          $username = substr("$aliasfile[0]",0,$maxaliaslength) ;

          $username =~ s/&/&amp;/g ;

          $username =~ s/</&lt;/g ;

          $username =~ s/>/&gt;/g ;

          $username =~ s/"/&quot;/g ;

          close (ALIASFILE) ;

        }

        print ("$username</A>") ;

        $comment = "" ;

        if (-e "$dirlocation$filename\/.comment") {

          open (COMMENTFILE, "<$dirlocation$filename\/.comment") ;

          @commentfile=<COMMENTFILE> ;

          $comment = substr("$commentfile[0]",0,$maxcommentlength) ;

          $comment =~ s/&/&amp;/g ;

          $comment =~ s/</&lt;/g ;

          $comment =~ s/>/&gt;/g ;

          $comment =~ s/"/&quot;/g ;

          close (COMMENTFILE) ;

        }

        print ("&nbsp;$comment</BR>\n") ;


      }

    }

  }

}

print <<EOF;
       </ol>

EOF
